/**
 * Project: MentDB
 * Project: MentDB
 * Description: Mentalese Database Engine
 * Website: http://www.mentdb.org
 * Twitter: https://twitter.com/mentalese_db
 * LinkedIn: https://www.linkedin.com/company/mentdb
 * Facebook: https://www.facebook.com/mentdb
 * Author: Jimmitry Payet
 * Website: http://www.jpayet.re
 * Mail: contact@jpayet.re
 * Locality: Reunion Island (French)
 */

package re.jpayet.mentdb.core.fx;

import java.util.Vector;

import re.jpayet.mentdb.core.command.Command;
import re.jpayet.mentdb.core.command.MQLValue;
import re.jpayet.mentdb.core.session.SessionThread;
import re.jpayet.mentdb.core.session.env.EnvManager;
import re.jpayet.mentdb.tools.Misc;

//The operator class
public class OperatorFx {
	
	//Add function
	public static String add(SessionThread session, Vector<MQLValue> parameters, EnvManager env) throws Exception {

		try {
			
			float f = 0;
			
			//Add all values
			for(int i=0;i<parameters.size();i++) {

				f += Double.parseDouble(parameters.get(i).value);

			}
			
			if ((""+f).endsWith(".0")) return (""+f).substring(0, (""+f).length()-2);
			else return (""+f);
			
		} catch (Exception e) {
			
			return null;
			
		}
		
	}
	
	//Sub function
	public static String sub(String number1, String number2) throws Exception {

		try {
			
			double f = (Double.parseDouble(number1)-Double.parseDouble(number2));
			
			if ((""+f).endsWith(".0")) return (""+f).substring(0, (""+f).length()-2);
			else return (""+f);
			
		} catch (Exception e) {
			
			return null;
			
		}
		
	}
	
	//Mul function
	public static String mul(String number1, String number2) throws Exception {

		try {
			
			double f = (Double.parseDouble(number1)*Double.parseDouble(number2));
			if ((""+f).endsWith(".0")) return (""+f).substring(0, (""+f).length()-2);
			else return (""+f);
			
		} catch (Exception e) {
			
			return null;
			
		}
		
	}
	
	//Div function
	public static String div(String number1, String number2) throws Exception {

		try {
			
			double f = (Double.parseDouble(number1)/Double.parseDouble(number2));
			if ((""+f).endsWith(".0")) return (""+f).substring(0, (""+f).length()-2);
			else return (""+f);
			
		} catch (Exception e) {
			
			return null;
			
		}
		
	}
	
	//And function
	public static String and(SessionThread session, String boolValue1, String boolValue2, EnvManager env) throws Exception {
		
		//Execute the first command
		String r1 = Command.executeAllCommands(false, session, Misc.splitCommand(boolValue1), env);
		
		if (r1==null) return "0";
		else if (r1.equals("1")) {
			
			//Execute the second command
			String r2 = Command.executeAllCommands(false, session, Misc.splitCommand(boolValue2), env);
			
			if (r2==null) return "0";
			else if (r2.equals("1")) return "1";
			else return "0";
			
		} else return "0";
		
	}
	
	//Or function
	public static String or(SessionThread session, String boolValue1, String boolValue2, EnvManager env) throws Exception {
		
		//Execute the first command
		String r1 = Command.executeAllCommands(false, session, Misc.splitCommand(boolValue1), env);
		
		if (r1==null) return "0";
		else if (r1.equals("1")) return "1";
		else {
			
			//Execute the second command
			String r2 = Command.executeAllCommands(false, session, Misc.splitCommand(boolValue2), env);
			
			if (r2==null) return "0";
			else if (r2.equals("1")) return "1";
			else return "0";
			
		}
		
	}
	
	//Xor function
	public static String xor(String boolValue1, String boolValue2) throws Exception {

		//Return the new boolean
		if (boolValue1==null || boolValue2==null) return "0";
		else if ((boolValue1.equals("1") && boolValue2.equals("0")) || (boolValue1.equals("0") && boolValue2.equals("1"))) return "1";
		else return "0";
		
	}
	
	//Not function
	public static String not(String bool) throws Exception {

		//Make the test
		if (bool==null) return null;
		else if (bool.equals("0")) return "1";
		else return "0";
		
	}
	
	//Is empty function
	public static String is_empty(String value) throws Exception {

		if (value==null) {
			return "0";
		} else if (value.equals("")) {
			return "1";
		} else {
			return "0";
		}
		
	}
	
	//Is not empty function
	public static String is_not_empty(String value) throws Exception {

		return not(is_empty(value));
		
	}
	
	//Equal function
	public static String equal(String value1, String value2) throws Exception {

		//Test
		if (value1==null && value2==null) {
			
			//All values are null (equal)
			return "1";
			
		} else if (value1==null) {
			
			//Here values are not equal
			return "0";
			
		} else if (value2==null) {
			
			//Here values are not equal
			return "0";
			
		} else {
			
			//Check if data of the two values are equal
			if (value1.equals(value2)) return "1";
			else return "0";
			
		}
		
	}
	
	//Not equal function
	public static String not_equal(String value1, String value2) throws Exception {

		return not(equal(value1, value2));
		
	}
	
	//Num equal function
	public static String num_equal(String number1, String number2) throws Exception {

		try {
			
			//Make the test
			if (Double.parseDouble(number1)==Double.parseDouble(number2)) return "1";
			else return "0";
			
		} catch (Exception e) {
			
			return "0";
			
		}
		
	}
	
	//Not num equal function
	public static String not_num_equal(String value1, String value2) throws Exception {

		return not(num_equal(value1, value2));
		
	}
	
	//Greater function
	public static String greater(String number1, String number2) throws Exception {

		try {
			
			//Check if greater
			if (Double.parseDouble(number1)>Double.parseDouble(number2)) return "1";
			else return "0";
			
		} catch (Exception e) {
			
			return "0";
			
		}
		
	}
	
	//Greater or equal function
	public static String greater_or_equal(String number1, String number2) throws Exception {

		try {
			
			//Check if greater
			if (Double.parseDouble(number1)>=Double.parseDouble(number2)) return "1";
			else return "0";
			
		} catch (Exception e) {
			
			return "0";
			
		}
		
	}
	
	//Less function
	public static String less(String number1, String number2) throws Exception {

		try {
			
			//Check if greater
			if (Double.parseDouble(number1)<Double.parseDouble(number2)) return "1";
			else return "0";
			
		} catch (Exception e) {
			
			return "0";
			
		}
		
	}
	
	//Less or equal function
	public static String less_or_equal(String number1, String number2) throws Exception {

		try {
			
			//Check if greater
			if (Double.parseDouble(number1)<=Double.parseDouble(number2)) return "1";
			else return "0";
			
		} catch (Exception e) {
			
			return "0";
			
		}
		
	}
	
	//Is not null
	public static String is_not_null(String value) {
		
		if (value==null) {
			return "0";
		} else {
			return "1";
		}
		
	}
	
	//Is null
	public static String is_null(String value) {
		
		if (value==null) {
			return "1";
		} else {
			return "0";
		}
		
	}
	
	//Is null or empty
	public static String is_null_or_empty(String value) {
		
		if (value==null || value.equals("")) {
			return "1";
		} else {
			return "0";
		}
		
	}

}
